//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Shortcut.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//

static inline void ValidCtrCheck(TShortcut *)
{
        new TShortcut(NULL);
}
//---------------------------------------------------------------------------
__fastcall TShortcut::TShortcut(TComponent* Owner)
        : TComponent(Owner)
{
}
//---------------------------------------------------------------------------
namespace Shortcut
{
        void __fastcall PACKAGE Register()
        {
                 TComponentClass classes[1] = {__classid(TShortcut)};
                 RegisterComponents("Alexis Ros", classes, 0);
        }
}
//---------------------------------------------------------------------------
void __fastcall TShortcut::CreateShortcut(const AnsiString &file, String description)
{
    IShellLink* pLink;
    IPersistFile* pPersistFile;
    LPMALLOC      ShellMalloc;
    LPITEMIDLIST  DesktopPidl;
    char DesktopDir[MAX_PATH];
    // We are going to create a pidl, and it will need to be
    // freed by the shell mallocator. Get the shell mallocator
    // object using API SHGetMalloc function. Return if failure.
    if(FAILED(SHGetMalloc(&ShellMalloc)))
            return;
    // use the API to get a pidl for the desktop directory
    // if function fails, return without proceeding
    if(FAILED(SHGetSpecialFolderLocation(NULL,
                                         CSIDL_DESKTOPDIRECTORY,
                                         &DesktopPidl)))
          return;
    // Now convert the pidl to a character string    // return if function fails
    if(!SHGetPathFromIDList(DesktopPidl, DesktopDir))
    {
        ShellMalloc->Free(DesktopPidl);
        ShellMalloc->Release();
        return;
    }
    // At this point, we are done with the pidl and the
    // mallocator, so free them up
    ShellMalloc->Free(DesktopPidl);
    ShellMalloc->Release();
    if(SUCCEEDED(CoInitialize(NULL)))
    {
        if(SUCCEEDED(CoCreateInstance(CLSID_ShellLink, NULL,
                                      CLSCTX_INPROC_SERVER,
                                      IID_IShellLink, (void **) &pLink)))
        {
            pLink->SetPath(file.c_str());
            pLink->SetDescription("This is a shortcut");
            pLink->SetShowCmd(SW_SHOW);
            if(SUCCEEDED(pLink->QueryInterface(IID_IPersistFile,
                                               (void **)&pPersistFile)))
            {
                WideString strShortCutLocation(DesktopDir);
                description +=".lnk";
                strShortCutLocation += "\\" + description;
                pPersistFile->Save(strShortCutLocation.c_bstr(), TRUE);
                pPersistFile->Release();
            }
            pLink->Release();
         }
     CoUninitialize();
   }
}

